<?php
// $Id: FeedsSelfNodeProcessor.inc,v 1.1 2011/01/27 08:00:28 twistor Exp $

/**
 * @file
 * Class definition of FeedsSelfNodeProcessor.
 */

/**
 * Allows a feed node to populate fields on itself.
 */
class FeedsSelfNodeProcessor extends FeedsNodeProcessor {
  /**
   * We always return the existing node id.
   */
  protected function existingEntityId($source, $result) {
    return $source->feed_nid;
  }

  /**
   * Override parent:entityLoad(). Change the log note.
   */
  protected function entityLoad(FeedsSource $source, $nid) {
    $node = parent::entityLoad($source, $nid);
    $node->log = 'Updated by FeedsSelfNodeProcessor';
    return $node;
  }

  /**
   * Override parent::configDefaults().
   */
  public function configDefaults() {
    $defaults = parent::configDefaults();
    $defaults['update_existing'] = FEEDS_UPDATE_EXISTING;
    $defaults['expire'] = FEEDS_EXPIRE_NEVER;
    return $defaults;
  }

  /**
   * Override parent::configForm().
   */
  public function configForm(&$form_state) {
    $form = parent::configForm($form_state);
    $form['expire']['#type'] = 'hidden';
    unset($form['update_existing']);
    unset($form['content_type']);
    $form['author']['#type'] = 'hidden';
    return $form;
  }
}
